function [x,ni]=Newtonvect(f,fd,x0,ea,er,nmax)
%NEWTON - metoda lui Newton pentru ecuatii neliniare in R si R^n
%apel [z,ni]=Newton(f,fd,x0,ea,er,nmax)
%Intrare
%f - functia
%fd - derivata
%x0 - aproximatia initiala 
%ea - eroarea absoluta
%er - eroarea relativa
%nmax - numarul maxim de iteratii
%Iesire
%z - aproximatia radacinii
%ni - numarul de iteratii

if nargin < 6, nmax=50; end
if nargin < 5, er=0; end
if nargin < 4, ea=1e-3; end
xp=x0(:);   %x precedent
x=zeros(length(x0),nmax+1);
x(:,1)=x0(:);
for k=1:nmax
    x(:,k+1)=x(:,k)-fd(x(:,k))\f(x(:,k)); 
    %fprintf('x(%2d)=%f\n', k, x(:,k+1));
    if (norm(x(:,k+1)-x(:,k),inf)<ea+er*norm(x(:,k+1),inf))...
            &&norm(f(x(:,k+1)),inf)<ea
        x=x(1:k+1); %succes
        ni=k;
        return
    end
end
ni=nmax;
warning('S-a depasit numarul maxim de iteratii');
