function  basinNewtonf(f,fd,a,b,c,d,n1,n2,m)
%basinNewton - basin of attraction for Newton method
%call basinNewtonf(f,fd,a,b,n,m)
% f, fd - function and its derivative
% a,b - interval
% n #points
% m #iterations
if nargin < 9, m=30; end
if nargin < 8, n2=1000; end
if nargin < 7, n1=1000; end
if nargin < 6, d=1; end
if nargin < 5, c=-1; end
if nargin < 4, b=1; end
if nargin < 3, a=-1; end

x=a:2*(b-a)/n1:b;
y=c:2*(d-c)/n2:d;
[X,Y]=meshgrid(x,y);
Z=X+1i*Y;
for i=1:m
    Z=Z-f(Z)./fd(Z);
end
image([a,b],[c,d],(round(imag(Z))+2)*20);
% figure()
% contourf(X,Y,(round(imag(Z))+2)*20)
