function fpgeom2(f,a,b,n)
xg=linspace(a,b,100); deplx=0.025; depl=0.2;
yg=f(xg);
fa=f(a); fb=f(b);
z=fzero(f,a,b);
plot(xg,yg,'k-',[a,b],[0,0],'b-')
hold on
plot([a,b,z],[0,0,0],'o',[a,a],[0,fa],'b--',[b,b],[0,fb],'b--');
text(a-deplx,0,'$a$','VerticalAlignment','middle','HorizontalAlignment','right',...
    'Interpreter','LaTEX','Fontsize',20,'FontName','TimesNewRoman');
text(a-deplx,f(a)/2,'$f(a)$','VerticalAlignment','middle','HorizontalAlignment','right',...
    'Interpreter','LaTEX','Fontsize',20,'FontName','TimesNewRoman');
text(b+deplx,0,'$b$','VerticalAlignment','middle','HorizontalAlignment','left',...
    'Interpreter','LaTEX','Fontsize',20,'FontName','TimesNewRoman');
text(b+deplx,f(b)/2,'$f(b)$','VerticalAlignment','middle','HorizontalAlignment','left',...
    'Interpreter','LaTEX','Fontsize',20,'FontName','TimesNewRoman');

for k=1:n
    x=a-(a-b)*fa/(fa-fb);
    fx=f(x);
    plot([a,b],[fa,fb],'k--'); plot(x,0,'o');
    s=sprintf('$c_%d$',k);
    text(x,0-depl,s,'VerticalAlignment','top','HorizontalAlignment','center',...
    'Interpreter','LaTEX','Fontsize',20,'FontName','TimesNewRoman');
    if sign(fx)==sign(fa)
        a=x; fa=fx;
    else
        b=x; fb=fx;
    end %if
end %for
text(z,0-depl,'$\alpha$','VerticalAlignment','top','HorizontalAlignment','center',...
    'Interpreter','LaTEX','Fontsize',20,'FontName','TimesNewRoman');
hold off